//! The I/O Prelude. <br>I/O Prelude。<br>
//!
//! The purpose of this module is to alleviate imports of many common I/O traits by adding a glob import to the top of I/O heavy modules: <br>该模块的目的是通过在 I/O 重型模块的顶部添加全局导入来减轻许多常见 I/O traits 的导入：<br>
//!
//!
//! ```
//! # #![allow(unused_imports)]
//! use std::io::prelude::*;
//! ```

#![stable(feature = "rust1", since = "1.0.0")]

#[stable(feature = "rust1", since = "1.0.0")]
pub use super::{BufRead, Read, Seek, Write};
