//! Owned and borrowed Unix-like file descriptors. <br>拥有和借用类 Unix 文件描述符。<br>

#![stable(feature = "io_safety", since = "1.63.0")]
#![deny(unsafe_op_in_unsafe_fn)]

// `RawFd`, `AsRawFd`, etc. <br>`RawFd`、`AsRawFd` 等<br>
pub mod raw;

// `OwnedFd`, `AsFd`, etc. <br>`OwnedFd`、`AsFd` 等<br>
pub mod owned;

// Implementations for `AsRawFd` etc. for network types. <br>`AsRawFd` 等网络类型的实现。<br>
mod net;

#[cfg(test)]
mod tests;
