use fortanix_sgx_abi::Tcs;

/// 获取当前线程的 ID。
/// 该 ID 在安全区内所有当前正在运行的线程中保证是唯一的，并且对于该线程的生命周期保证是恒定的。
///
/// 更具体地说，对于 SGX，ID 与 TCS 的地址一一对应。
#[unstable(feature = "sgx_platform", issue = "56975")]
pub fn current() -> Tcs {
    extern "C" {
        fn get_tcs_addr() -> Tcs;
    }
    unsafe { get_tcs_addr() }
}
