use fortanix_sgx_abi::Tcs;

/// Gets the ID for the current thread. <br>获取当前线程的 ID。<br>
/// The ID is guaranteed to be unique among all currently running threads in the enclave, and it is guaranteed to be constant for the lifetime of the thread. <br>该 ID 在安全区内所有当前正在运行的线程中保证是唯一的，并且对于该线程的生命周期保证是恒定的。<br>
///
/// More specifically for SGX, there is a one-to-one correspondence of the ID to the address of the TCS. <br>更具体地说，对于 SGX，ID 与 TCS 的地址一一对应。<br>
#[unstable(feature = "sgx_platform", issue = "56975")]
pub fn current() -> Tcs {
    extern "C" {
        fn get_tcs_addr() -> Tcs;
    }
    unsafe { get_tcs_addr() }
}
