use super::alloc::copy_to_userspace;
use super::alloc::User;

#[test]
fn test_copy_function() {
    let mut src = [0u8; 100];
    let mut dst = User::<[u8]>::uninitialized(100);

    for i in 0..src.len() {
        src[i] = i as _;
    }

    for size in 0..48 {
        // 对于所有可能的对齐
        for offset in 0..8 {
            // 覆盖完整的 dst
            dst.copy_from_enclave(&[0u8; 100]);

            // 复制 src[0..size] 到 dst + offset
            unsafe { copy_to_userspace(src.as_ptr(), dst.as_mut_ptr().offset(offset), size) };

            // 验证副本
            for byte in 0..size {
                unsafe {
                    assert_eq!(*dst.as_ptr().offset(offset + byte as isize), src[byte as usize]);
                }
            }
        }
    }
}
