use crate::sys::pipe::{anon_pipe, Pipes};
use crate::{thread, time};

/// Test the synchronous fallback for overlapped I/O. <br>测试重叠 I/O 的同步回退。<br>
#[test]
fn overlapped_handle_fallback() {
    // Create some pipes. <br>创建一些管道。<br> `ours` will be asynchronous. <br>`ours` 将是异步的。<br>
    let Pipes { ours, theirs } = anon_pipe(true, false).unwrap();

    let async_readable = ours.into_handle();
    let sync_writeable = theirs.into_handle();

    thread::scope(|_| {
        thread::sleep(time::Duration::from_millis(100));
        sync_writeable.write(b"hello world!").unwrap();
    });

    // The pipe buffer starts empty so reading won't complete synchronously unless our fallback path works. <br>管道缓冲区开始为空，因此除非我们的后备路径有效，否则读取不会同步完成。<br>
    //
    let mut buffer = [0u8; 1024];
    async_readable.read(&mut buffer).unwrap();
}
