use crate::sys::pipe::{anon_pipe, Pipes};
use crate::{thread, time};

/// 测试重叠 I/O 的同步回退。
#[test]
fn overlapped_handle_fallback() {
    // 创建一些管道。`ours` 将是异步的。
    let Pipes { ours, theirs } = anon_pipe(true, false).unwrap();

    let async_readable = ours.into_handle();
    let sync_writeable = theirs.into_handle();

    thread::scope(|_| {
        thread::sleep(time::Duration::from_millis(100));
        sync_writeable.write(b"hello world!").unwrap();
    });

    // 管道缓冲区开始为空，因此除非我们的后备路径有效，否则读取不会同步完成。
    //
    let mut buffer = [0u8; 1024];
    async_readable.read(&mut buffer).unwrap();
}
