/// CONTROL register <br>控制寄存器<br>
pub struct CONTROL;

rsr!(CONTROL);
wsr!(CONTROL);

/// Execution Program Status Register <br>执行程序状态寄存器<br>
pub struct EPSR;

rsr!(EPSR);

/// Interrupt Program Status Register <br>中断程序状态寄存器<br>
pub struct IPSR;

rsr!(IPSR);

/// Main Stack Pointer <br>主栈指针<br>
pub struct MSP;

rsrp!(MSP);
wsrp!(MSP);

/// Priority Mask Register <br>优先级掩码寄存器<br>
pub struct PRIMASK;

rsr!(PRIMASK);
wsr!(PRIMASK);

/// Process Stack Pointer <br>进程栈指针<br>
pub struct PSP;

rsrp!(PSP);
wsrp!(PSP);

/// Program Status Register <br>程序状态寄存器<br>
#[allow(non_camel_case_types)]
pub struct xPSR;

rsr!(xPSR);
