//! 实用程序宏。

// 辅助结构体用于当 const 泛型 immediate 值 `imm` 不是整数时触发 const eval 错误。
//
pub(crate) struct ValidateConstRound<const IMM: i32>;
impl<const IMM: i32> ValidateConstRound<IMM> {
    pub(crate) const VALID: () = {
        assert!(
            IMM == 4 || IMM == 8 || IMM == 9 || IMM == 10 || IMM == 11,
            "Invalid IMM value"
        );
    };
}

#[allow(unused)]
macro_rules! static_assert_rounding {
    ($imm:ident) => {
        let _ = $crate::core_arch::x86_64::macros::ValidateConstRound::<$imm>::VALID;
    };
}

// 辅助结构体用于在 const 泛型 immediate 值 `imm` 不是 sae 数时触发 const eval 错误。
//
pub(crate) struct ValidateConstSae<const IMM: i32>;
impl<const IMM: i32> ValidateConstSae<IMM> {
    pub(crate) const VALID: () = {
        assert!(IMM == 4 || IMM == 8, "Invalid IMM value");
    };
}

#[allow(unused)]
macro_rules! static_assert_sae {
    ($imm:ident) => {
        let _ = $crate::core_arch::x86_64::macros::ValidateConstSae::<$imm>::VALID;
    };
}
